Last modified: 2014-11-11 14:47:06 UTC

Wikimedia Bugzilla is closed!

Wikimedia has migrated from Bugzilla to Phabricator. Bug reports should be created and updated in Wikimedia Phabricator instead. Please create an account in Phabricator and add your Bugzilla email address to it.
Wikimedia Bugzilla is read-only. If you try to edit or create any bug report in Bugzilla you will be shown an intentional error message.
In order to access the Phabricator task corresponding to a Bugzilla report, just remove "static-" from its URL.
You could still run searches in Bugzilla or access your list of votes but bug reports will obviously not be up-to-date in Bugzilla.
Bug 15071 - Wikibooks/Wikisource needs means to associate separate pages with books
Wikibooks/Wikisource needs means to associate separate pages with books
Status: ASSIGNED
Product: Wikimedia
Classification: Unclassified
General/Unknown (Other open bugs)
unspecified
All All
: Low enhancement with 5 votes (vote)
: ---
Assigned To: Deepali Jain
http://en.wikibooks.org/w/index.php?t...
:
: 382 1900 (view as bug list)
Depends on: 50386
Blocks: 10092 12908 15072 15073 15074 15075 26448 31254 Wikisource 15070
  Show dependency treegraph
 
Reported: 2008-08-07 17:59 UTC by Mike.lifeguard
Modified: 2014-11-11 14:47 UTC (History)
20 users (show)

See Also:
Web browser: ---
Mobile Platform: ---
Assignee Huggle Beta Tester: ---


Attachments

Description Mike.lifeguard 2008-08-07 17:59:15 UTC
Wikibooks needs some way of noting what is a book in the database. This bug blocks many Wikibooks-specific feature requests.

Some discussion on this has happened previously:
*http://en.wikibooks.org/w/index.php?title=Wikibooks:Reading_room/Feature_requests&oldid=1230990#How_to_represent_books_in_the_database
*http://lists.wikimedia.org/pipermail/textbook-l/2008-April/001248.html
Comment 1 Chad H. 2008-08-07 22:52:14 UTC
I wouldn't say a custom schema. I would think an extension (that will probably add a table or two ;-)) would accomplish it rather well. Keep individual pages as-is, then create a specialpage to "Create a book" and pick pages that go into it. Independent of individual "pages", so each "page" can be updated, just as the wiki is now. With this book metadata stored, you can then begin interfacing with it (AJAX-based book reader, automated table-of-contents, search-in-specific book).
Comment 2 Mike.lifeguard 2008-08-08 17:30:03 UTC
Call it what you will, we need some way of identifying books in the database.

CCing Darklama, as he has thought about this.
Comment 3 Siebrand Mazeland 2008-08-10 23:04:29 UTC
Remove keyword schema-change. There is no patch.
Comment 4 Siebrand Mazeland 2008-08-10 23:07:12 UTC
This is a very specialised feature request(like the dependencies). I seems to me like you should make a comprehensive plan and maybe present it to the Wikimedia Foundation, or a well funded Wikimedia chapter, or some other foundation, for funding. Then develop an extension that gives you what you need to get a proper WikiBooks.

Setting to 'Wikimedia' and 'enhancement'
Comment 5 Platonides 2008-08-10 23:10:03 UTC
There's a http://www.mediawiki.org/wiki/Extension:AllBooks to partly? solve this (linked from the ml msg)
Comment 6 Mike.lifeguard 2008-09-17 00:47:51 UTC
(In reply to comment #5)
> There's a http://www.mediawiki.org/wiki/Extension:AllBooks to partly? solve
> this (linked from the ml msg)
> 

There are several issues with that:
1) no caching
2) relies on a consistently-applied naming scheme
3) /only counts/lists books - can't be used for anything else we want
4) probably there are coding issues (such as manually entering the regex in a system message - apparently not a good idea for this limited set of functions, and even worse due to reason 3)
5) probably stuff I don't know about
Comment 7 p858snake 2010-07-05 01:13:11 UTC
Could we use some of them liquid threads code to do the page chaining so it "links" them together, Then all it would need is some sort of syntax to go in the page to tell it what what book it is apart of.
Comment 8 Helder 2010-08-26 20:41:49 UTC
Just a side note: the necessity of such a feature was pointed out even before the Wikibooks project was live. Daniel Mayer[1] in Jun 2003:
> Textbooks are organized in a very different way than an encyclopedia and they 
> also have a specific audience. These two things make textbook material 
> completely incompatible with Wikipedia. Thus a separate project is needed 
> (and probably a few tweaks to the software to make it easy to have chapters).

So, in this sense, this bug is 7 years old!

[1] http://lists.wikimedia.org/pipermail/wikien-l/2003-June/004788.html
Comment 9 Aashish Mittal 2012-02-13 17:14:31 UTC
Hello,

I am looking forward to pursue this issue as my GSoC project.

I have gone through the links and documentation related with this issue. Based on that, I have come up with an initial list of deliverables. The project needs to implement following set of features:

1 Create a book
2 Page addition wizard (also containing search filters for finding particular pages)
3 Import book metadata (my suggestion where user can directly add set of pages from his export list)
4 Export book metadata (export the book details containing all page links to a file which can be saved by user, similar to MetaBooks)
5 Add to a book option for every page 
6 Table of contents for a book
7 Read a book
8 Recent changes for each book
9 Create chapters
10 Manage book:
	- Arrange order of pages in a book
	- Protect/watchlist/move/delete all pages
11 List books
12 Search for a book 
13 Search in a book
..(any more which would be required)

I have installed the Collection and BookManager extensions and am going through their code base. I would like to ask if it is possible to reuse the existing functionalities from the extensions (ex. Book and chapter creation from Collection, navigation from BookManager, book listing from AllBooks, etc) and extend them to add the rest of features over these functionalities. 

Secondly, going through http://en.wikibooks.org/w/index.php?title=Wikibooks:Reading_room/Feature_requests&oldid=1230990#How_to_represent_books_in_the_database suggests multiple ways of implementing the backend. It would be great if someone could guide what would be considered the most suitable way of storing the book metadata. Figuring out these basics and a proper scope would enable me to go more in depth and think from implementation perspective.

Thanks,
Aashish
Comment 10 Helder 2012-02-13 17:44:34 UTC
Hi!

Thank you for your interest on helping our projects! This is really appreciated!

You may want to get in touch with Wikibooks and Wikisource communities through their mailing lists and Village Pumps, asking for any feedback which may help you on this task (such as identifying other requirements not yet mentioned here on bugzilla). So, here are some useful links:
== Wikibooks ==
* Mailing List: https://lists.wikimedia.org/mailman/listinfo/textbook-l
* English Project: https://en.wikibooks.org/wiki/Wikibooks:Reading_room/Technical_Assistance

== Wikisource ==
* Mailing List: https://lists.wikimedia.org/mailman/listinfo/wikisource-l
* English Project: https://en.wikisource.org/wiki/Wikisource:Scriptorium
* Multilingual project: https://wikisource.org/wiki/Wikisource:Scriptorium

Maybe it would be better to have a central place where editors from all projects could participate in the discussion (since not everybody has a bugzilla account or is subscribed to the mailing lists). I suggest creating a page such as
https://meta.wikimedia.org/wiki/Books
(better name?) on Meta-wiki. For an example of a page discussing a similar initiative see:
https://meta.wikimedia.org/wiki/Wikidata

Best regards
Comment 11 Aashish Mittal 2012-02-13 19:22:21 UTC
Hello,

Thanks for the suggestions.

I have created this page https://meta.wikimedia.org/wiki/Books Will be using this for further development and plans on this project.

Also, will be joining the wikibooks and wikisources mailing list and post an introduction to this project. Will ask for their feedback for the same.

Hope to get this project into action soon.

Thanks,
Aashish
Comment 12 Helder 2012-02-18 11:33:17 UTC
*** Bug 382 has been marked as a duplicate of this bug. ***
Comment 13 Helder 2012-02-18 11:34:22 UTC
*** Bug 1900 has been marked as a duplicate of this bug. ***
Comment 14 billinghurst 2013-03-14 02:44:25 UTC
Is this now something that should be considered as something that is more related to a push to get data into Wikidata?
Comment 15 Raylton P. Sousa 2013-03-14 12:19:35 UTC
(In reply to comment #14)
> Is this now something that should be considered as something that is more
> related to a push to get data into Wikidata?

Maybe. But this would only be really useful for the  wikibooks if, in the future, wikidata is able to solve all blocked bugs. Mainly bug 15073.
Comment 16 Molly White 2013-04-11 16:24:05 UTC
Hello! I'm planning to submit a proposal for Google Summer of Code 2013 (and also Outreach Program for Women) that will address this bug. I plan to improve the BookManager extension to a point where it can be deployed on Wikisource, Wikibooks, etc. This will allow users to combine different pages into a single book, which will then be treated as a single unit. Once this is accomplished, many of the bugs this bug blocks will be able to be addressed.

My full proposal is available at https://www.mediawiki.org/wiki/User:GorillaWarfare/Proposal. I'd really love to get some feedback on this! I'd also like to hear any opinions you might have about its feasibility as a GSoC project, and its relative priority.
Comment 17 Raylton P. Sousa 2013-04-11 17:11:34 UTC
I can help you Molly :)
Comment 18 Molly White 2013-04-11 17:18:52 UTC
(In reply to comment #17)
> I can help you Molly :)

Wonderful! Did you get the email I sent yesterday?
Comment 19 Raylton P. Sousa 2013-04-11 17:24:21 UTC
Oh dear, I lost it in my inbox, I'm so sorry.
I'll see...
Comment 20 Quim Gil 2013-04-23 21:15:57 UTC
Just a note to say that Molly White has applied to GSoC with a proposal related to this report. Good luck!

https://www.mediawiki.org/wiki/User:GorillaWarfare/Proposal
Comment 21 Molly White 2013-06-10 16:34:27 UTC
Hello! I'd just like to update you all on this project that is related to this bug. I submitted a proposal (https://www.mediawiki.org/wiki/User:GorillaWarfare/Proposal) to Wikimedia for Google Summer of Code, and have been accepted to work on it this summer. I will be working with Raylton P. Sousa and Matthew Walker as my mentors.

I am currently working on creating documentations to plan the project, which you can see at http://meta.wikimedia.org/wiki/Book_management. Any feedback on my work there or on the project in general is more than welcome. I will begin working on the actual code on June 17.
Comment 22 Molly White 2013-06-24 19:17:00 UTC
I have created an RfC (http://www.mediawiki.org/wiki/Requests_for_comment/Book_management) to get community feedback on the extension I hope to create. Feedback would be wonderful!
Comment 23 Quim Gil 2013-09-17 16:17:26 UTC
GSoC "soft pencils down" date was yesterday and all coding must stop on 23 September. Has this project been completed?
Comment 24 Raylton P. Sousa 2013-09-17 18:55:00 UTC
No entirely . Currently we do not have the ability to work with very large books (Bug 52435).

And we have no tool for migration of existing books (Bug 53286).

But some dependences of Bug 15073 have been fixed (Bug 31075, Bug 54231 and Bug 54234)
And we move in the production of a solid tool to manage books in our own bug list:
https://bugzilla.wikimedia.org/buglist.cgi?component=BookManagerv2&product=MediaWiki%20extensions&list_id=234100

Molly! Correct me if I'm wrong.
Comment 25 Molly White 2013-09-18 00:21:21 UTC
That's correct, Raylton.

We've been using the bug priority list at https://meta.wikimedia.org/w/index.php?title=Book_management/Bug_priority to organize the bugs on Bugzilla, and it might provide a little more insight into our progress. The bolded bugs are the as-yet unfixed ones that we've decided need to be fixed before we move on to the security review.
Comment 26 Molly White 2013-10-01 21:38:24 UTC
I've wrapped up this Summer of Code project with the extension mostly complete, but with a number of open bugs. I've written a blog post on it at http://www.mollywhite.net/blog/?p=104
Comment 27 Quim Gil 2013-10-22 19:36:43 UTC
If you have open tasks or bugs left, one possibility is to list them at https://www.mediawiki.org/wiki/Google_Code-In and volunteer yourself as mentor.

We have heard from Google and free software projects participating in Code-in that students participating in this programs have done a great work finishing and polishing GSoC projects, many times mentores by the former GSoC student. The key is to be able to split the pending work in little tasks.

More information in the wiki page. If you have questions you can ask there or you can contact me directly.
Comment 28 Raylton P. Sousa 2013-10-22 19:52:40 UTC
Yes.. We have 33 not fixed bugs[1]. I think Bug 52347 and Bug 50679 will be quite simple to Code-in

[1]https://bugzilla.wikimedia.org/buglist.cgi?component=BookManagerv2&resolution=---&list_id=243412
Comment 29 Andre Klapper 2013-11-08 15:19:05 UTC
Raylton: Great. Please check https://www.mediawiki.org/wiki/Google_Code-in#Become_a_Wikimedia_GCI_mentor
Comment 30 Nemo 2014-01-18 07:54:23 UTC
(In reply to comment #28)
> Yes.. We have 33 not fixed bugs[1]. I think Bug 52347 and Bug 50679 will be
> quite simple to Code-in

34 now. Raylton or Molly, can either of you make this bug into a request to review and deploy the extension on Wikimedia projects, adding the actual requirements to blockers? It's currently impossible to understand what's the status of the project and how far or close it is to its goals.
Comment 31 Raylton P. Sousa 2014-02-21 13:56:55 UTC
Bookmanager v2 (in its reading interface) would be ready if you do not have to migrate all books (Wikisource/wikibooks) to the new extension. 

I Mean... It works well for:
* New books (created after the extension already installed) and small (less than 5,000 pages, I think) 
It does not work well for: 
* Ancient books (created before the extension to be installed) - Bug 53286
* Big Books (more than 5,000 pages, I think) - Bug 52435

Of course there are other bugs, but I think these are, currently, the main blockers

Thanks for the comment.

Best regards!
Comment 32 Deepali Jain 2014-03-21 18:18:00 UTC
Hello!

I am planning to work on the open issues of Bookmanagerv2 extension as a part of GSoC and OPW 2014, especially the following bugs:

Bug 51239
Bug 53286
Bug 52435

The major focus is on creating a user-friendly, easy-to-use and efficient interface for book editing and reading and migration of existing books to Bookmanagerv2 extension.

Here is my proposal:

https://www.mediawiki.org/wiki/User:Jaindeepali/Proposal#Book_management_in_Wikibooks.2FWikisource

Please provide your opinions and feedback regarding the same. :)
Comment 33 Deepali Jain 2014-03-21 18:19:13 UTC
Hello!

I am planning to work on the open issues of Bookmanagerv2 extension as a part of GSoC and OPW 2014, especially the following bugs:

Bug 51239
Bug 53286
Bug 52435

The major focus is on creating a user-friendly, easy-to-use and efficient interface for book editing and reading and migration of existing books to Bookmanagerv2 extension.

Here is my proposal:

https://www.mediawiki.org/wiki/User:Jaindeepali/Proposal

Please provide your opinions and feedback regarding the same. :)
Comment 34 Nemo 2014-04-24 10:45:53 UTC
Updated assignee given https://www.mediawiki.org/wiki/Book_management .
Comment 35 Quim Gil 2014-09-12 09:30:54 UTC
Deepali's GSoC project was evaluated as PASSED, but it is unclear what is the current status, and the required final blog post seems to be missing.

https://meta.wikimedia.org/wiki/Book_management_2014/Progress

Please wrap up the project properly, documenting any task left open.

Note You need to log in before you can comment on or make changes to this bug.


Navigation
Links